"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function renderNodeList(nodes, context) {
    let r = "";
    for (const node of nodes) {
        if (typeof node === "object") {
            if (node !== null) {
                if (Array.isArray(node)) {
                    r += renderNodeList(node, context);
                }
                else {
                    r += _renderToString(node, context);
                }
            }
        }
        else if (typeof node === "string") {
            r += node;
        }
        else if (typeof node === "number") {
            r += node.toString();
        }
    }
    return r;
}
function _renderToString(node, context) {
    let c;
    if (node.type === 0 /* Component */) {
        c = node.fn(context, node.props);
    }
    else {
        c = node.children;
        context = Object.assign({}, context, node.context);
    }
    if (typeof c === "string") {
        return c;
    }
    if (typeof c === "number") {
        return c.toString();
    }
    if (typeof c === "object" && c !== null) {
        if (Array.isArray(c)) {
            return renderNodeList(c, context);
        }
        return _renderToString(c, context);
    }
    return "";
}
function renderToString(node) {
    return _renderToString(node, {});
}
exports.renderToString = renderToString;
//# sourceMappingURL=render.js.map