import { Context } from "./context";
export declare const enum TNodeType {
    Component = 0,
    Context = 1,
}
export declare type TNode = ComponentNode<any> | ContextNode;
export declare type TChildren = TNodeList | TNode | string | number | null;
export interface TNodeList extends Array<TChildren> {
}
export interface ComponentNode<P = null> {
    readonly type: TNodeType.Component;
    readonly fn: (context: Context, props: P) => TChildren;
    readonly props: P;
}
export interface ContextNode {
    readonly type: TNodeType.Context;
    readonly context: {
        [key: string]: string;
    };
    readonly children: TChildren;
}
export declare function context(ctx: Context, children: TChildren): ContextNode;
export declare function component(fn: () => TChildren): ComponentNode<undefined>;
export declare function component(fn: (context: Context) => TChildren): ComponentNode<undefined>;
export declare function component<T>(fn: (context: Context, props: T) => TChildren, props: T): ComponentNode<T>;
export declare function componentFactory(fn: (context: Context) => TChildren): () => TChildren;
export declare function componentFactory<T>(fn: (context: Context, props: T) => TChildren): (props: T) => TChildren;
